/*
 *   ORXONOX - the hottest 3D action shooter ever to exist
 *                    > www.orxonox.net <
 *
 *
 *   License notice:
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *   Author:
 *      Florian Zinggeler
 *   Co-authors:
 *      ...
 *
 */

/**
    @file AsteroidsStone.h
    @brief Declaration of the AsteroidsStone class.
*/

#ifndef _AsteroidsStone_H__
#define _AsteroidsStone_H__

#include "asteroids/AsteroidsPrereqs.h"

#include "worldentities/Pawn.h"

namespace orxonox
{
    class _AsteroidsExport AsteroidsStone : public Pawn
    {
        public:
            AsteroidsStone(Context* context);
            virtual void tick(float dt) override;

            //Radius of the asteroid
            float r;
            int level;
            virtual void setAsteroidsPlayer(AsteroidsShip* player){this->player = player;}

        protected:

            //herausfinden->ueber Kamera Einstellung wie bei Pong?
            float fieldWidth_=500;
            float fieldHeight_=700;
            Vector2 velocity;
            float maxspeed;
    };
}

#endif /* _AsteroidsStone_H__ */
